<template>
    <div
        id="app"
        :class="[
            'app',
             {
                 'index-page': $route.path === '/'
             }
        ]"
        :style="[circleBackground ? {'background': '#1D3956'} : {}]"
    >
        <div
            v-show="load"
            class="app__load"
        >
            {{ $t('event.load') }}
        </div>
        <loader v-if="$loader" />
        <div
            v-show="!load"
            class="app__content"
        >
            <template-header />
            <router-view />
            <template-footer />
        </div>
        <base-background-circle
            v-if="!circleBackground"
            class="index-page__background-circle"
        />
    </div>
</template>

<script>
import Loader from '@/components/Loader';
import TemplateFooter from 'src/templates/TemplateFooter';
import TemplateHeader from 'src/templates/TemplateHeader';

export default {
    name: 'app',
    components: {
        Loader,
        TemplateFooter,
        TemplateHeader
    },
    data() {
        return {
            load: true
        };
    },
    computed: {
        circleBackground() {
            return ['profile', 'settings', 'oisUpload'].includes(this.$route.name);
        }
    },
    async created() {
        await this.checkAuthorized();
        await this.generateToken();
        this.tokenUpdateInterval();
        this.load = true;
        const vm = this;
        setTimeout(function() {
            vm.load = false;
        }, 100);
    },
    mounted() {
        this.setScreenProperties({ width: window.screen.width, height: window.screen.height });
        window.addEventListener('resize', e => {
            const { width, height } = e.target.screen;
            this.setScreenProperties({ width, height });
        });
    },
    methods: {
        ...mapActions('information', ['setScreenProperties']),
        ...mapActions('account', ['checkAuthorized', 'generateToken', 'tokenUpdateInterval'])
    }
};
</script>

<style lang="sass">
    @import '~assets/styles/index.sass';
</style>
